import { UpdateFilter } from 'mongodb';
import { ApiCall } from "tsrpc";
import { CollectionEvent } from '../../../module/collection_event';
import { PayFun } from '../../../public/pay';
import { ReqOpen, ResOpen } from "../../../shared/protocols/event/shiwuleichong/PtlOpen";
import { PublicShared } from '../../../shared/public/public';

export default async function (call: ApiCall<ReqOpen, ResOpen>) {
    let db = await G.mongodb.cEvent('15leichong').findOne({ uid: call.uid, type: '15leichong' });
    let update: UpdateFilter<CollectionEvent<'15leichong'>>;
    let sTime = PublicShared.getToDayZeroTime(G.time);

    if (!db) {
        update = {
            $set: { index: 0, sTime: sTime, recIndex: [] }
        };
    } else {
        if (db.sTime + G.gc.shiwuleichong.data[db.index].time < G.time) {

            db.sTime = sTime;
            db.index = G.gc.shiwuleichong.data[db.index + 1] == undefined ? db.index : db.index + 1;
            db.recIndex = [];

            update = {
                $set: { index: db.index, sTime: db.sTime, recIndex: [] }
            };
        } else {
            sTime = db.sTime;
        }
    }

    update && G.mongodb.cEvent('15leichong').updateOne({ uid: call.uid, type: '15leichong' }, update, { upsert: true });
    let index = db?.index || 0;

    call.succ({
        index: index,
        sTime: sTime,
        recIndex: db?.recIndex || [],
        payDay: await PayFun.getPayDaysBuyPayNum(call.uid, sTime, sTime + G.gc.shiwuleichong.data[index].time, G.gc.shiwuleichong.dayPayNeed)
    });
}