import { ApiCall } from "tsrpc";
import { PayFun } from '../../../public/pay';
import { PlayerFun } from '../../../public/player';
import { ReqRec, ResRec } from "../../../shared/protocols/event/shiwuleichong/PtlRec";

export default async function (call: ApiCall<ReqRec, ResRec>) {
    let db = await G.mongodb.cEvent('15leichong').findOne({ uid: call.uid, type: '15leichong' });
    let confArr = G.gc.shiwuleichong.data[db.index];

    if (!confArr.tasks[call.req.index]) return call.error('', { code: -1 });
    if (db.recIndex.includes(call.req.index)) return call.error('', { code: -2 });

    let payDay = await PayFun.getPayDaysBuyPayNum(call.uid, db.sTime, db.sTime + confArr.time, G.gc.shiwuleichong.dayPayNeed);
    if (payDay < confArr.tasks[call.req.index].total) return call.error('', { code: -3 });

    await PlayerFun.sendPrize(call, confArr.tasks[call.req.index].prize);

    G.mongodb.cEvent('15leichong').updateOne(
        { uid: call.uid, type: '15leichong' },
        { $push: { recIndex: call.req.index } }
    );

    call.succ({
        prize: confArr.tasks[call.req.index].prize
    });
}