

export class UserShared {
    /**获取头像之类id */
    static getInfoId(type: 'head' | 'headFrame' | 'chatFrame' | 'model', id: string, pos?: string) {
        return Array.from(arguments).filter(s => s != '').join('_');
    }
    /**
     * 判断头像之类是否激活 
     * @param id 请使用 UserShared.getInfo 转化后的id
     */
    static chechIsActive(fmtId: string, collection: Partial<{ lv: number, vip: number, lsyx: k_v<number>, active: k_v<number>; }>) {

        const [type, id, pos] = fmtId.split('_');
        const jsonName = 'player' + type.slice(0, 1).toLocaleUpperCase() + type.slice(1);
        const json = G.gc[jsonName] as any;
        const conf: _gcType['playerHead'][''] = pos ? json[pos][id] : json[id];

        if (conf.cond[0] == 'lv') return collection.lv >= conf.cond[1];
        else if (conf.cond[0] == 'vip') return collection.vip >= conf.cond[1];
        else if (conf.cond[0] == 'hero') return collection.lsyx[conf.cond[1]] > 0;
        else if (conf.cond[0] == 'time') return collection.active[fmtId] == -1 || collection.active[fmtId] > G.time;
        else return false;
    }
}